VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Zelda 3 saveram - savestate searcher"
   ClientHeight    =   4005
   ClientLeft      =   45
   ClientTop       =   435
   ClientWidth     =   5085
   Icon            =   "Form1.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   4005
   ScaleWidth      =   5085
   StartUpPosition =   2  'CenterScreen
   Begin VB.TextBox txtState2Bin 
      Height          =   285
      Left            =   1680
      TabIndex        =   11
      Top             =   3120
      Width           =   975
   End
   Begin VB.TextBox txtState1Bin 
      Height          =   285
      Left            =   1680
      TabIndex        =   7
      Top             =   2760
      Width           =   975
   End
   Begin VB.TextBox txtAddressHex 
      Height          =   285
      Left            =   1680
      TabIndex        =   6
      Top             =   2160
      Width           =   855
   End
   Begin VB.CommandButton cmdPickSaveState2 
      Caption         =   "Savestate 2"
      Height          =   255
      Left            =   3720
      TabIndex        =   5
      Top             =   480
      Width           =   1215
   End
   Begin MSComDlg.CommonDialog dlgFile 
      Left            =   4560
      Top             =   3480
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
      Filter          =   "ZSNES savestate files| *.zs?"
   End
   Begin VB.CommandButton cmdPickSaveState1 
      Caption         =   "Savestate 1"
      Height          =   255
      Left            =   3720
      TabIndex        =   4
      Top             =   120
      Width           =   1215
   End
   Begin VB.TextBox txtSavestate2 
      Height          =   285
      Left            =   1560
      TabIndex        =   3
      Top             =   480
      Width           =   2055
   End
   Begin VB.TextBox txtSavestate1 
      Height          =   285
      Left            =   1560
      TabIndex        =   2
      Top             =   120
      Width           =   2055
   End
   Begin VB.ListBox lstAddresses 
      Height          =   3570
      ItemData        =   "Form1.frx":038A
      Left            =   120
      List            =   "Form1.frx":038C
      TabIndex        =   1
      Top             =   120
      Width           =   1335
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Compare"
      Height          =   495
      Left            =   2520
      TabIndex        =   0
      Top             =   1200
      Width           =   1335
   End
   Begin VB.Label Label3 
      Caption         =   "Current Value Binary"
      Height          =   255
      Left            =   2760
      TabIndex        =   10
      Top             =   3120
      Width           =   1575
   End
   Begin VB.Label Label2 
      Caption         =   "Previous Value Binary"
      Height          =   255
      Left            =   2760
      TabIndex        =   9
      Top             =   2760
      Width           =   1575
   End
   Begin VB.Label Label1 
      Caption         =   "Hex Address"
      Height          =   210
      Left            =   2640
      TabIndex        =   8
      Top             =   2160
      Width           =   975
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim SaveState1(1280) As Byte
Dim SaveState2(1280) As Byte
Public SaveStateName1 As String
Public SaveStateName2 As String
Dim arrValues() As String
Private Sub Command1_Click()
 lstAddresses.Clear
 
 'make sure two savestates are picked
 If txtSavestate1 = "" Or txtSavestate2 = "" Then
  MsgBox "You need to pick two savestate files to compare"
  Exit Sub
 End If
 
 'load the two areas of savestates into memory
 Open SaveStateName1 For Binary As #1
 For Tempi = 64532 To 65811
  Get #1, Tempi, SaveState1(Tempi - 64532)
 Next Tempi
 Close #1
 Open SaveStateName2 For Binary As #1
 For Tempi = 64532 To 65811
  Get #1, Tempi, SaveState2(Tempi - 64532)
 Next Tempi
 Close #1
 
 For Tempi = 0 To 1280
  If SaveState1(Tempi) <> SaveState2(Tempi) Then
   lstAddresses.AddItem Tempi & " " & SaveState1(Tempi) & " " & SaveState2(Tempi)
  End If
 Next Tempi
End Sub
Private Sub cmdPickSaveState1_Click()
 dlgFile.ShowOpen
 If dlgFile.FileName = "" Then Exit Sub
 SaveStateName1 = dlgFile.FileName
 txtSavestate1 = dlgFile.FileTitle
End Sub
Private Sub cmdPickSaveState2_Click()
 dlgFile.ShowOpen
 If dlgFile.FileName = "" Then Exit Sub
 SaveStateName2 = dlgFile.FileName
 txtSavestate2 = dlgFile.FileTitle
End Sub
Private Sub Form_Load()
 dlgFile.InitDir = App.Path
End Sub
Private Sub Form_Unload(Cancel As Integer)
 frmZelda3.Visible = True
End Sub
Private Function Binary(Value As Byte)
 Temps = (Value And 128) / 128
 Temps = Temps & (Value And 64) / 64
 Temps = Temps & (Value And 32) / 32
 Temps = Temps & (Value And 16) / 16
 Temps = Temps & (Value And 8) / 8
 Temps = Temps & (Value And 4) / 4
 Temps = Temps & (Value And 2) / 2
 Temps = Temps & (Value And 1)
 Binary = Temps
End Function

Private Sub lstAddresses_Click()
 arrValues = Split(lstAddresses.Text, " ")
 txtAddressHex = Hex(arrValues(0)) & "h"
 txtState1Bin = Binary(Val(arrValues(1)))
 txtState2Bin = Binary(Val(arrValues(2)))
End Sub

